** STATA SYNTAX TO ESTIMATE CUBIC SPLINES AND KERNEL REGRESSIONS FOR 10 RANDOM SAMPLES (sample1,..., sample10).
 
   ** INSTALL B-SPLINE PACKAGE
   ** CLICK ON THE FIRST LINK SUGGESTED
   findit bspline
   
   ** IMPORT DATA
	insheet using "C:\Users\uqaberna.GEOSCIPLNG\Documents\Stata.csv"

   ** ESTIMATE CUBIC SPLINE -  NO LOOP
   ** Knots every three years from 15 to 30, and every 5 years other ages

	bspline, xvar(age) knots (5 10 15 18 21 24 27 30 35 40 45 50 55 60) p(3) gen(_aks)

	quietly regress sample1 _aks*, noconstant
	predict sample1_cs

	quietly regress sample2 _aks*, noconstant
	predict sample2_cs

	quietly regress sample3 _aks*, noconstant
	predict sample3_cs

	quietly regress sample4 _aks*, noconstant
	predict sample4_cs

	quietly regress sample5 _aks*, noconstant
	predict sample5_cs

	quietly regress sample6 _aks*, noconstant
	predict sample6_cs

	quietly regress sample7 _aks*, noconstant
	predict sample7_cs

	quietly regress sample8 _aks*, noconstant
	predict sample8_cs

	quietly regress sample9 _aks*, noconstant
	predict sample9_cs

	quietly regress sample10 _aks*, noconstant
	predict sample10_cs

	** ESTIMATE CUBIC SPLINE -  WITH LOOP OVER A 1,000 SAMPLES
	bspline, xvar(age) knots (5 10 15 18 21 24 27 30 35 40 45 50 55 60 65 70 75 80 85 90) p(3) gen(_aks)
	foreach var of varlist sample_1-sample_1000 {
	quietly regress `var'  _aks*, noconstant
	predict `var'_cs
	}
	

   ** ESTIMATE A GAUSSIAN KERNEL REGRESSION WITH NO LOOP
	lpoly  sample1  age, at (age) k(gauss) gen(sample1_kr)
	lpoly  sample2  age, at (age) k(gauss) gen(sample2_kr)
	lpoly  sample3  age, at (age) k(gauss) gen(sample3_kr)
	lpoly  sample4  age, at (age) k(gauss) gen(sample4_kr)
	lpoly  sample5  age, at (age) k(gauss) gen(sample5_kr)
	lpoly  sample6  age, at (age) k(gauss) gen(sample6_kr)
	lpoly  sample7  age, at (age) k(gauss) gen(sample7_kr)
	lpoly  sample8  age, at (age) k(gauss) gen(sample8_kr)
	lpoly  sample9  age, at (age) k(gauss) gen(sample9_kr)
	lpoly  sample10 age, at (age) k(gauss) gen(sample10_kr)

	** STIMATE A GAUSSIAN KERNEL REGRESSION WITH NO LOOP -  WITH LOOP OVER A 1,000 SAMPLES
	foreach var of varlist sample_1-sample_1000 {
	lpoly `var'  age, at (age) k(gauss) gen(`var'_kr)nograph 
	}
	