 % SYNTAX TO ESTIMATE THE STANDARD MODEL MIGRATION SCHEDULE WITH AN UPDWARD ELDERLY SLOPE (9 PARAMETER FUNCTION) IN MATLAB
% FILE AMENDED FROM  Rogers, A., Little, J., & Raymer, J. (2010).The indirect estimation of migration: methods for dealing with irregular, inadequate, and missing data. Dordrecht: Springer.

% CHANGE THE PATH TO POINT TO THE DATA
  C_profile=xlsread('C:\Users\uqaberna.GEOSCIPLNG\Documents\MATLAB.xls');
% MATLAB.xls CONTAINS SINGLE-YEAR INTER-PROVINCIAL MIGRATION AGE PROFILES FOR 10 RANDOMLY GENERATED n=250,000 SAMPLES FROM THE 2002 CHILEAN CENSUS

% SET INITIAL PARAMETER VALUES
  a1=0.02;
  alpha1=0.03;
  a2=0.028;
  alpha2=0.1;
  mu2=28;
  lambda2=0.4;
  a3=0.0029;
  alpha3=0.003;
  c=0.003;
 beta0=[a1 alpha1 a2 alpha2 mu2 lambda2 a3 alpha3 c];
% PARAMETER CONSTRAINTS
  lb(1)=0;
  ub(1)=Inf;
  lb(2)=0;
  ub(2)=Inf;
  lb(3)=0;
  ub(3)=Inf;
  lb(4)=0;
  ub(4)=Inf;
  lb(5)=0;
  ub(5)=Inf;
  lb(6)=0;
  ub(6)=Inf;
  lb(7)=0;
  ub(7)=Inf;
  lb(8)=0;
  ub(8)=Inf;
  lb(9)=0;
  ub(9)=Inf;
 n=length(C_profile);
 R=zeros(n-1,1);
 Y_pred=C_profile;
 beta=zeros(n,length(beta0))
% RUN REGRESSION
% CHANGE THE NUMBER OF AGE PROFILES TO BE FITTED HERE, CURRENTLY SET TO READ 10 AGE PROFILES 
  for i=1:1000
  Y=C_profile(i+1,:);
  X=C_profile(1,:);
% options =
  optimset('Jacobian','on','TolFun',.0000000001,'MaxFunEvals',100000000,'MaxIter',10000000);
  [beta(i,:),resnorm,residual] = lsqcurvefit(@exp9param,beta0,X,Y,lb,ub);
  [beta(i,:),resnorm,residual] = lsqcurvefit(@exp9param,beta(i,:),X,Y,lb,ub);
  [beta(i,:),resnorm,residual] = lsqcurvefit(@exp9param,beta(i,:),X,Y,lb,ub);
  Y_pred(i,:)=exp9param(beta(i,:),X);
  end
%SAVE PREDICTED VALUES 
  save -ascii p9pred_long_distance25000.txt Y_pred  -double
  


